git-repack.shon commit Merge branch 'kf/post-receive-sample-hook' into maint (6cf9bf6)
   1#!/bin/sh
   2#
   3# Copyright (c) 2005 Linus Torvalds
   4#
   5
   6OPTIONS_KEEPDASHDASH=
   7OPTIONS_SPEC="\
   8git repack [options]
   9--
  10a               pack everything in a single pack
  11A               same as -a, and turn unreachable objects loose
  12d               remove redundant packs, and run git-prune-packed
  13f               pass --no-reuse-delta to git-pack-objects
  14F               pass --no-reuse-object to git-pack-objects
  15n               do not run git-update-server-info
  16q,quiet         be quiet
  17l               pass --local to git-pack-objects
  18 Packing constraints
  19window=         size of the window used for delta compression
  20window-memory=  same as the above, but limit memory size instead of entries count
  21depth=          limits the maximum delta depth
  22max-pack-size=  maximum size of each packfile
  23"
  24SUBDIRECTORY_OK='Yes'
  25. git-sh-setup
  26
  27no_update_info= all_into_one= remove_redundant= unpack_unreachable=
  28local= no_reuse= extra=
  29while test $# != 0
  30do
  31        case "$1" in
  32        -n)     no_update_info=t ;;
  33        -a)     all_into_one=t ;;
  34        -A)     all_into_one=t
  35                unpack_unreachable=--unpack-unreachable ;;
  36        -d)     remove_redundant=t ;;
  37        -q)     GIT_QUIET=t ;;
  38        -f)     no_reuse=--no-reuse-delta ;;
  39        -F)     no_reuse=--no-reuse-object ;;
  40        -l)     local=--local ;;
  41        --max-pack-size|--window|--window-memory|--depth)
  42                extra="$extra $1=$2"; shift ;;
  43        --) shift; break;;
  44        *)      usage ;;
  45        esac
  46        shift
  47done
  48
  49case "`git config --bool repack.usedeltabaseoffset || echo true`" in
  50true)
  51        extra="$extra --delta-base-offset" ;;
  52esac
  53
  54PACKDIR="$GIT_OBJECT_DIRECTORY/pack"
  55PACKTMP="$GIT_OBJECT_DIRECTORY/.tmp-$$-pack"
  56rm -f "$PACKTMP"-*
  57trap 'rm -f "$PACKTMP"-*' 0 1 2 3 15
  58
  59# There will be more repacking strategies to come...
  60case ",$all_into_one," in
  61,,)
  62        args='--unpacked --incremental'
  63        ;;
  64,t,)
  65        args= existing=
  66        if [ -d "$PACKDIR" ]; then
  67                for e in `cd "$PACKDIR" && find . -type f -name '*.pack' \
  68                        | sed -e 's/^\.\///' -e 's/\.pack$//'`
  69                do
  70                        if [ -e "$PACKDIR/$e.keep" ]; then
  71                                : keep
  72                        else
  73                                existing="$existing $e"
  74                        fi
  75                done
  76                if test -n "$existing" -a -n "$unpack_unreachable" -a \
  77                        -n "$remove_redundant"
  78                then
  79                        args="$args $unpack_unreachable"
  80                fi
  81        fi
  82        ;;
  83esac
  84
  85args="$args $local ${GIT_QUIET:+-q} $no_reuse$extra"
  86names=$(git pack-objects --keep-true-parents --honor-pack-keep --non-empty --all --reflog $args </dev/null "$PACKTMP") ||
  87        exit 1
  88if [ -z "$names" ]; then
  89        say Nothing new to pack.
  90fi
  91
  92# Ok we have prepared all new packfiles.
  93mkdir -p "$PACKDIR" || exit
  94
  95# First see if there are packs of the same name and if so
  96# if we can move them out of the way (this can happen if we
  97# repacked immediately after packing fully.
  98rollback=
  99failed=
 100for name in $names
 101do
 102        for sfx in pack idx
 103        do
 104                file=pack-$name.$sfx
 105                test -f "$PACKDIR/$file" || continue
 106                rm -f "$PACKDIR/old-$file" &&
 107                mv "$PACKDIR/$file" "$PACKDIR/old-$file" || {
 108                        failed=t
 109                        break
 110                }
 111                rollback="$rollback $file"
 112        done
 113        test -z "$failed" || break
 114done
 115
 116# If renaming failed for any of them, roll the ones we have
 117# already renamed back to their original names.
 118if test -n "$failed"
 119then
 120        rollback_failure=
 121        for file in $rollback
 122        do
 123                mv "$PACKDIR/old-$file" "$PACKDIR/$file" ||
 124                rollback_failure="$rollback_failure $file"
 125        done
 126        if test -n "$rollback_failure"
 127        then
 128                echo >&2 "WARNING: Some packs in use have been renamed by"
 129                echo >&2 "WARNING: prefixing old- to their name, in order to"
 130                echo >&2 "WARNING: replace them with the new version of the"
 131                echo >&2 "WARNING: file.  But the operation failed, and"
 132                echo >&2 "WARNING: attempt to rename them back to their"
 133                echo >&2 "WARNING: original names also failed."
 134                echo >&2 "WARNING: Please rename them in $PACKDIR manually:"
 135                for file in $rollback_failure
 136                do
 137                        echo >&2 "WARNING:   old-$file -> $file"
 138                done
 139        fi
 140        exit 1
 141fi
 142
 143# Now the ones with the same name are out of the way...
 144fullbases=
 145for name in $names
 146do
 147        fullbases="$fullbases pack-$name"
 148        chmod a-w "$PACKTMP-$name.pack"
 149        chmod a-w "$PACKTMP-$name.idx"
 150        mv -f "$PACKTMP-$name.pack" "$PACKDIR/pack-$name.pack" &&
 151        mv -f "$PACKTMP-$name.idx"  "$PACKDIR/pack-$name.idx" ||
 152        exit
 153done
 154
 155# Remove the "old-" files
 156for name in $names
 157do
 158        rm -f "$PACKDIR/old-pack-$name.idx"
 159        rm -f "$PACKDIR/old-pack-$name.pack"
 160done
 161
 162# End of pack replacement.
 163
 164if test "$remove_redundant" = t
 165then
 166        # We know $existing are all redundant.
 167        if [ -n "$existing" ]
 168        then
 169                ( cd "$PACKDIR" &&
 170                  for e in $existing
 171                  do
 172                        case " $fullbases " in
 173                        *" $e "*) ;;
 174                        *)      rm -f "$e.pack" "$e.idx" "$e.keep" ;;
 175                        esac
 176                  done
 177                )
 178        fi
 179        git prune-packed ${GIT_QUIET:+-q}
 180fi
 181
 182case "$no_update_info" in
 183t) : ;;
 184*) git update-server-info ;;
 185esac